<?php declare(strict_types=1);

namespace Lubiana\DoctrineUlid\IdGenerator;

use Doctrine\ORM\EntityManagerInterface;
use Doctrine\ORM\Id\AbstractIdGenerator;
use Symfony\Component\Uid\Factory\UlidFactory;
use Symfony\Component\Uid\Ulid;

final class UlidGenerator extends AbstractIdGenerator
{
    public function __construct( private readonly ?UlidFactory $factory = null ){}
    public function generateId(EntityManagerInterface $em, ?object $entity): mixed
    {
        if ($this->factory !== null) {
            return $this->factory->create();
        }

        return new Ulid();
    }
}